// $Id: ErrHist.cc,v 1.1.2.3 1998/11/18 07:23:43 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#include "AppDef.h"
#include "ErrHist.h"

#include <string.h>


ErrHist TheErrHist("Errors", E_CUSTOM_END);

// XXX: this array must be in sync with E_ enumeration
static const char *TheCustomErrStrs[E_CUSTOM_END - E_CUSTOM_FIRST] = {
	"foreign reply format",
	"foreign request format",
	"premature end of reply",
	"premature end of request",
	"conn establishment timed out"
};

const char *ErrHist::itemStr(int idx) const {
	if (idx < E_CUSTOM_FIRST)
		return strerror(idx);
	else
		return TheCustomErrStrs[idx - E_CUSTOM_FIRST];
}
