// $Id: AppDef.h,v 1.9.2.1 1998/09/22 07:43:55 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef _APP_DEF_H_
#define _APP_DEF_H_

#ifdef FD_SETSIZE
#error FD_SETSIZE is already defined
#undef FD_SETSIZE
#endif
#define FD_SETSIZE 4096

#include <stdlib.h>  /* for abort() */
#include <errno.h>
#include <string.h>

#include <iostream.h>
#include <iomanip.h>


// XXX: to be refined later
inline void Assert(bool cond) { if (!cond) ::abort(); }

#define Check(cond) DoCheck((cond), __FILE__, __LINE__);

// XXX: to be refined later
inline 
void DoCheck(bool cond, const char *file, int lineno) {
	if (!cond) {
		cerr << file << ':' << lineno << ": error(?): (" << errno << ") " <<  strerror(errno) << endl;
		::exit(-errno);
	}
}

#endif
