// $Id: Hist.h,v 1.1.2.2 1998/09/22 07:44:06 rousskov Exp $

/*
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation, and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef _HIST_H_
#define _HIST_H_

#include "AppDef.h"

#include <iostream.h>

// a simple fixed size histogram of integer values
class Hist {
	public:
		Hist(const char *aLabel, int aCapacity);
		virtual ~Hist() { delete[] theTab; }

		void record(int n) { theTab[check(n)]++; }
		int &operator [](int idx) { return theTab[check(idx)]; }

		void report(ostream &os) const; // prints a report

	protected:
		// "human" interpretation of a value at given position
		virtual const char *itemStr(int) const { return ""; }

		int check(int n) const { return n < 0 ? 0 : (n >= theCapacity ? theCapacity-1 : n); }

	protected:
		int theCapacity;  // table size
		int *theTab;      // the table

		const char *theLabel;   // histogram name to use in reports
};

#endif
